// Cursor Demo C version
// Virtual-E (c) 1999-2000 <virtuale98@yahoo.com>
// Coded by Alberto Covarrubias

#include "vbaddr.h"		//You can use this header if you find it useful
#include "vbtypes.h"	//This header must be on your C file of you want to use the default library
#include "vbhw.h"		//This header is needed to include the default library

static HWORD chCursor[] = {
     0x0000,0x0500,0x5A50,0xAFA5,0xAFA5,0x5A50,0x0500,0x0000,
     0x0000,0x0050,0x05A5,0x5AFA,0x5AFA,0x05A5,0x0050,0x0000,
     0x03C0,0x0C30,0x300C,0x000C,0x000C,0x300C,0x0C30,0x03C0,
     0x300C,0x300C,0x300C,0x300C,0x300C,0x300C,0x0C30,0x03C0,
     0x03FC,0x0C0C,0x0C0C,0x0C0C,0x03FC,0x0C0C,0x300C,0x300C,
     0x0FF0,0x300C,0x000C,0x0FF0,0x3000,0x3000,0x300C,0x0FF0,
     0x03C0,0x0C30,0x300C,0x300C,0x300C,0x300C,0x0C30,0x03C0,
     0x03FC,0x0C0C,0x0C0C,0x0C0C,0x03FC,0x0C0C,0x300C,0x300C
};

static HWORD bgCursor[] = {0, 1, 2, 3, 4, 5, 6, 7};

void Init()
{
	VIP_REGS(0x24) = 0;
	VIP_REGS(0x26) = 0;
	VIP_REGS(0x28) = 0;
	VIP_REGS(0x60) = 0xE4;
	VIP_REGS(0x62) = 0xE4;
	VIP_REGS(0x64) = 0xE4;
	VIP_REGS(0x65) = 0xE4;
	VIP_REGS(0x66) = 0xE4;
	VIP_REGS(0x6A) = 0xE4;
	VIP_REGS(0x6C) = 0xE4;
	VIP_REGS(0x6E) = 0xE4;
	VIP_REGS(0x70) = 0;
}

void Cursor()
{
	int x = 0;

	vbSetWorld(31,0xC000,0x60+x,2,0x6F,0,0,0,7,7);	
	vbSetWorld(30,0xC000,0x78,2,0x60,16,0,0,47,7);	
	vbSetWorld(29,0x0040,0,0,0,0,0,0,0,0);
	vbDisplayOn();
	vbFXFadeIn();

	while(1)
	{
		for(x=0;x < 0x60;x++)
		{
			vbSetWorld(31,0xC000,0x60+x,2,0x6F,0,0,0,7,7);
			vbWaitFrame(15);
		}
		for(x=0x60;x > 0;x--)
		{
			vbSetWorld(31,0xC000,0x60+x,2,0x6F,0,0,0,7,7);
			vbWaitFrame(15);
		}
	}
}

void main()	//The compiler accept only a void main(), not an int prototype with args.
{
	int i=0;
	vbReset();
	Init();
	memcpy((void*)CharSeg0, (void*)chCursor, 8*16);
	memcpy((void*)BGMap(0), (void*)bgCursor, 16);
	Cursor();
}


